#include "StdAfx.h"
#include "GameTalkAPIGlobal.h"
#include "WASListNameSearch.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"

CWASListNameSearch::CWASListNameSearch(CWASActor *pActor): 
CWASCommand(pActor)
{
	m_nSearchTotal = 0;
    m_nRetPage = 0;
}

CWASListNameSearch::~CWASListNameSearch(void)
{
}

void CWASListNameSearch::ExecuteAsync()
{
	m_listResultPrivate.clear();
	m_listResult.clear();

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if (pMessengerActor == NULL)
	{
		return;
	}	

	USES_UTF8_CONVERSION;

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/org/SearchMember02.php");

	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("keyword", W2U8(m_param.strSearchText));
	m_httpFacade.session().AddBodyVariable("langcode", W2U8(m_param.strLangCode));
	m_httpFacade.session().AddBodyVariable("function_list", W2U8(m_param.strFunction));
	m_httpFacade.session().AddBodyVariable("cnt_per_page", "50");
	m_httpFacade.session().AddBodyVariable("sort_col", W2U8(m_param.strSortCol));
	m_httpFacade.session().AddBodyVariable("sort_asc", W2U8(m_param.strSortAsc));
	m_httpFacade.session().AddBodyVariable("dept_id", W2U8(m_param.strDeptId));
	m_httpFacade.session().AddBodyVariable("user_lv", W2U8(m_param.strLevel));

	// Page size
	char page[5] = {0,};
	itoa(m_param.nPage, page, 10);
	m_httpFacade.session().AddBodyVariable("page_no", page);

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}

bool CWASListNameSearch::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	if(pDom == NULL)
		return false;
	//CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	//ASSERT_IF_FAIL_RETURN_VALUE(pMessengerActor, false);

	//CProfileImageActor *pProfileImageActor = static_cast<CProfileImageActor *>(pMessengerActor->GetProfileImageActor());
	//ASSERT_IF_FAIL_RETURN_VALUE(pProfileImageActor, false);

	nfc::IIkXMLNode* pNode = pDom->GetdocumentElement()->selectSingleNode("nodes");
	nfc::IIkXMLAttribute* pAttr;
	if (pNode == NULL)
	{
		m_strWasErrMsg += _T("˻ Ϳ \" <nodes>\"  ã  ϴ.");
		return false;
	}
	else
	{
		if (NULL != (pAttr = pNode->getAttribute("total")))
			m_nSearchTotal = atoi(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("page_no")))
			m_nRetPage = atoi(pAttr->Gettext().c_str());
	}

	nfc::IIkXMLNodeList *pList = pNode->selectNodes("node");	
	USES_UTF8_CONVERSION;
	m_listResultPrivate.clear();

	for (int i = 0; i < pList->Getlength(); i++)
	{
		NE_MEMBER_DATA sResultPrivate;// Ź  ʱȭ
		pNode = pList->Getitem(i);
		GT_ASSERT(pNode);

		if (NULL == (pAttr = pNode->getAttribute("user_id")))// ʼ
			continue;	// ignore this item

		sResultPrivate.strUserId = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("emp_nm")))
			sResultPrivate.strName = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("dept_nm")))
			sResultPrivate.strDept = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("dept_id")))
			sResultPrivate.strDeptId = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbps_nm")))
			sResultPrivate.strJobPos = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbps_cd")))
			sResultPrivate.strJobPosCd = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbdt_nm")))
			sResultPrivate.strJobDuty = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("jbdt_cd")))
			sResultPrivate.strJobDutyCd = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("inco_tel_no")))		// ȣ
			sResultPrivate.strExtesion = U82W(pAttr->Gettext().c_str());
		
		if (NULL != (pAttr = pNode->getAttribute("tel_no")))			// ȸȣ
			sResultPrivate.strIncoTel = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("fax_no")))
			sResultPrivate.strFaxNum = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("cph_no")))
			sResultPrivate.strCellPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("ipph_no")))
			sResultPrivate.strIPPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("email_addr")))
			sResultPrivate.strEmail = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("rmngph_no")))
			sResultPrivate.strRmngPhone = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("kwd_nm")))
			sResultPrivate.strKeyword = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("workpl_nm")))
			sResultPrivate.strWorkPlace = U82W(pAttr->Gettext().c_str());
		
		if (NULL != (pAttr = pNode->getAttribute("work_status")))
			sResultPrivate.strWorkStatus = U82W(pAttr->Gettext().c_str());

		m_listResultPrivate.push_back(sResultPrivate);
	}

	return true;
}

// override in drived class
void CWASListNameSearch::OnWasResponse(trid_t trid,
								   bool bSuccess,
								   int /*nWinINetErrorCode*/, 
								   int /*nHttpResponseCode*/, 
								   LPCSTR /*szWasResCodeInHeader*/, 
								   LPCSTR szWasResCodeInXml,
								   nfc::CIkXMLDom * pDom)
{
	if (bSuccess)
	{
		if (ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	// wstring LPCWSTR ȯؼ 迭  ־!!!
	for(size_t i = 0; i < m_listResultPrivate.size(); i++)
	{
		NE_MEMBER_DATA sTemp;
		sTemp = m_listResultPrivate[i];
		m_listResult.push_back(sTemp);
	}

	NE_SEARCH_MEMBER_DATA_LIST sList;
	sList.nSearchTotal = m_nSearchTotal;
	sList.nPage = m_nRetPage;
	sList.nSize = m_listResult.size();
	sList.pList = sList.nSize > 0 ? &m_listResult[0] : NULL;

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		pObserver->OnGTWASActor_ResponseNameSearchList(m_pActor, GetID(), m_eError, sList);
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASListNameSearch::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	// wstring LPCWSTR ȯؼ 迭  ־!!!
	for(size_t i = 0; i < m_listResultPrivate.size(); i++)
	{
		NE_MEMBER_DATA sTemp;
		sTemp = m_listResultPrivate[i];
		m_listResult.push_back(sTemp);
	}

	NE_SEARCH_MEMBER_DATA_LIST sList;
	sList.nSearchTotal = m_nSearchTotal;
	sList.nPage = m_nRetPage;
	sList.nSize = m_listResult.size();
	sList.pList = sList.nSize > 0 ? &m_listResult[0] : NULL;

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		pObserver->OnGTWASActor_ResponseNameSearchList(m_pActor, GetID(), m_eError, sList);
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
